/*
 * Copyright (C) 2006 boxon
 *
 * This file is part of M-SuDoKu, a J2ME version of SuDoKu.
 *
 * M-SuDoKu-JP is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * M-SuDoKu-JP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with M-SuDoKu; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.  Or, visit http://kumisuke.jp/boxon/gamessa/msudokujp/COPYING.txt
 */

package MSuDoKu;

/**
 * This class provides help with string constants and
 * multilanguage support (only English, Spanish and Italian at
 * the time being)
 *
 * @author Leopardo.f
 */

public class Utils {

    public static final String sAppName = "M-SuDoKu";
    public static final String sVersion = "v0.9.0";
    public static final String sSite = "http://phonphun.altervista.org";
    
    public static final String[] saITA = {"Menu", "Aiuto", "Livello", "Sfondo", "Info", "Metodo di input", "Ricomincia", "Mostra soluzione", "Salta questa griglia", "Salva ed esci", "Annulla", "OK"};
    public static final String[] saENG = {"Menu", "Help", "Level", "Background", "About", "Input mode", "Restart", "Show solution", "Skip this grid", "Save and exit", "Cancel", "Select"};
    public static final String[] saES = {"ƭ", "wv", "x", "wiݒ", "o[W", "͕@", "蒼", "", "VObh", "f", "ݾ", "I"};
    public static final int MENU = 0;
    public static final int HELP = 1;
    public static final int LEVEL = 2;
    public static final int BACKGROUND = 3;
    public static final int ABOUT = 4;
    public static final int INPUT = 5;
    public static final int RESTART = 6;
    public static final int SOLUTION = 7;
    public static final int SKIP = 8;
    public static final int EXIT = 9;
    public static final int CANCEL = 10;
    public static final int SELECT = 11;

    public static final String[] saLevelITA = {"Difficile", "Medio"};
    public static final String[] saLevelENG = {"Difficult", "Medium"};
    public static final String[] saLevelES = {"", ""};

    public static final String[] saInputITA = {"Tasti numerici", "Senza tasti num.", "Tasti num. + joypad"};
    public static final String[] saInputENG = {"With numpad", "Without numpad", "Numpad+Joypad"};
    public static final String[] saInputES = {"L[", "\L[", "\L[+L["};

    public static final String[] saTimeITA = {"ora/e", "minuti", "secondi"};
    public static final String[] saTimeENG = {"hour(s)", "minute(s)", "second(s)"};
    public static final String[] saTimeES = {"", "", "b"};

    public static final String HelpITA = "Scopo del gioco ?riempire tutta la griglia 9x9, " +
            "ponendo in ogni casella vuota un numero da 1 a 9 in modo che tale numero " +
            "compaia una sola volta nella riga, nella colonna e nel quadrato 3x3 cui " +
            "appartiene la casella. Ogni griglia presenta inizialmente un certo numero di " + 
            "caselle gi?riempite, che servono da aiuto nell\'inserimento dei numeri successivi.\n" +
            "Per giocare, muovi il cursore usando il joypad (o, a seconda del modello, " +
            "i tasti numerici), quindi premi il pulsante di fuoco (o il tasto 5) ed usa i tasti " +
            "numerici per inserire o sovrascrivere un numero nella casella selezionata (il tasto 0 " +
            "cancella un numero gi?inserito).\n" +
            "In alternativa, se il dispositivo non ha una tastiera numerica (o semplicemente se " +
            "vi risulta pi?comodo!) potete usare il menu per cambiare la modalit?di input, in " +
            "modo che i numeri possano essere inseriti nelle celle muovendo il joypad in su o in gi?\n" +
            "Inoltre, il menu del gioco permette di scegliere il livello di difficolt?(tra Medio " +
            "e Difficile), lo sfondo della griglia, di mostrare la soluzione, di ricominciare " + 
            "il gioco e di uscire salvando la griglia corrente.";
    public static final String HelpENG = "The aim of the puzzle is to enter a numeral " + 
            "from 1 through 9 in each cell of the grid (made up of 33 subgrids called regions), " +
            "starting with the numerals given in some cells.\n" +
            "Each row, column and region must contain only one instance of each numeral.\n" +
            "To play, move the cursor using joypad (or, depending on your device model, " +
            "numeric keys), press the fire button (or 5 key) and use numeric keys " +
            "to enter or overwrite a number in the selected cell (0 key deletes a previously entered " +
            "number).\n" +
            "Alternatively, if your device does not have a numeric keypad (or simply if you " +
            "feel more comfortable this way!) you can use the menu to change the input mode, so " +
            "that you can enter a number in a cell by repeatedly pushing the joypad up or down.\n" +
            "Moreover, game menu allows you to choose the difficulty level (either Medium " +
            "or Difficult), the grid background, to show the solution of the current grid, to " +
            "restart the game and to exit (saving the current grid).";
    public static final String HelpES = "19̐AcAA3x3̃}XɏdȂ悤" +
            "zuĂׂẴ}X𖄂߂ĂB" +
            "\L[܂2468L[ŃJ[\ړČL[܂5L[œ͏ԂɂȂ܂B\n" +
            "͏ԂŐ͂邩A\L[[h̏ꍇ̓L[̏㉺ŐI܂B\n" +
            "\L[+L[̓̓[hł͏\L[ŃJ[\ړAL[Œڐ͂܂B\n" +
            "܂AՓxA̓[hAwiȂǂj[ŕύXł܂B";
    public static final String AboutITA = sAppName + " " + sVersion + " (C) 2006 boxon\n" +
            "\n\n" +
            "M-SuDoKu-JP ?Software Libero ed ?distribuito sotto licenza GPL, versione 2 o superiore " +
            "(http://kumisuke.jp/boxon/gamessa/msudokujp/COPYING.txt).\n" + 
            "Il programma ?distribuito \"COS COM'\", senza alcun tipo di garanzia, n?implicita n?esplicita.";
    public static final String AboutENG = sAppName + " " + sVersion + " (C) 2006 boxon\n" +
            "\n\n" +
            "M-SuDoKu-JP is free software and is distributed under GPL version 2 or higher " +
            "(http://kumisuke.jp/boxon/gamessa/msudokujp/COPYING.txt).\n" +
            "The program is provided \"AS IS\" without any warranty of any kind, either expressed or implied.";
    public static final String AboutES = sAppName + " " + sVersion + " (C) 2006 boxon\n" +
            "\n\n" +
            "M-SuDoKu-JP ̓t[\tgŁAGPL CZXŔzzĂ܂B " +
            "(http://kumisuke.jp/boxon/gamessa/msudokujp/COPYING.txt).\n";

    public static final String CongratsITA = "CONGRATULAZIONI!!!\n" +
            "Puzzle risolto!!!\nTempo: ";
    public static final String CongratsENG = "CONGRATULATIONS!!!\n" +
            "Puzzle solved!!!\nTime: ";
    public static final String CongratsES = "߂łƂ܂!!!\n" +
            "Xe[WNA!!!\nTime: ";
    public static final String PuzzlesOverITA = "Non ci sono pi?puzzle da risolvere per questo livello di difficolt?\n" +
            "Visita " + sSite + " per altri puzzle!";
    public static final String PuzzlesOverENG = "No more puzzles to solve for the current level!\n" +
            "Please visit " + sSite + " for more puzzles!";
    public static final String PuzzlesOverES = "̃xׂ̖͂ăNA܂!\n" +
            "TCg " + sSite + " ւǂ!";
    
    public static final String[] saBackgroundITA = {"Nessuno", "Gocce", "Neve", "Dune", "Legno", "Riso"};
    public static final String[] saBackgroundENG = {"None", "Waterdrops", "Snow", "Dunes", "Wood", "Rice"};
    public static final String[] saBackgroundES = {"None", "Waterdrops", "Snow", "Dunes", "Wood", "Rice"};

    protected static final String sLang = System.getProperty ("microedition.locale");

/**
 * Returns the list of labels for the main menu
 */    
    public static String[] getStringTable()
    {
        if (sLang == null)
            return saENG;
        if (sLang.startsWith ("it"))
            return saITA;
        else if (sLang.startsWith ("ja"))
            return saES;
        else
            return saENG;
    }

/**
 * Returns the list of strings for the different levels available
 */    
    public static String[] getLevel()
    {
        if (sLang == null)
            return saLevelENG;
        if (sLang.startsWith ("it"))
            return saLevelITA;
        else if (sLang.startsWith ("ja"))
            return saLevelES;
        else
            return saLevelENG;
    }

/**
 * Returns the list of strings for time units
 */    
    public static String[] getTime()
    {
        if (sLang == null)
            return saTimeENG;
        if (sLang.startsWith ("it"))
            return saTimeITA;
        else if (sLang.startsWith ("ja"))
            return saTimeES;
        else
            return saTimeENG;
    }

/**
 * Returns the list of strings for the different input modes available
 */    
    public static String[] getInput()
    {
        if (sLang == null)
            return saInputENG;
        if (sLang.startsWith ("it"))
            return saInputITA;
        else if (sLang.startsWith ("ja"))
            return saInputES;
        else
            return saInputENG;
    }

 /**
 * Returns the list of descriptive text for backgrounds
 */    
    public static String[] getBackground()
    {
        if (sLang == null)
            return saBackgroundENG;
        if (sLang.startsWith ("it"))
            return saBackgroundITA;
        else if (sLang.startsWith ("ja"))
            return saBackgroundES;
        else
            return saBackgroundENG;
    }

/**
 * Returns text for the About Alert
 */    
    public static String getAbout()
    {
        if (sLang == null)
            return AboutENG;
        if (sLang.startsWith ("it"))
            return AboutITA;
        else if (sLang.startsWith ("ja"))
            return AboutES;
        else
            return AboutENG;
    }

/**
 * Returns text for the Help Alert
 */    
    public static String getHelp()
    {
        if (sLang == null)
            return HelpENG;
        if (sLang.startsWith ("it"))
            return HelpITA;
        else if (sLang.startsWith ("ja"))
            return HelpES;
        else
            return HelpENG;
    }

/**
 * Returns text for the Congratulations Alert
 */    
    public static String getCongrats()
    {
        if (sLang == null)
            return CongratsENG;
        if (sLang.startsWith ("it"))
            return CongratsITA;
        else if (sLang.startsWith ("ja"))
            return CongratsES;
        else
            return CongratsENG;
    }

/**
 * Returns text displayed if all puzzle for the current level have been solved
 */    
    public static String getPuzzlesOver()
    {
        if (sLang == null)
            return PuzzlesOverENG;
        if (sLang.startsWith ("it"))
            return PuzzlesOverITA;
        else if (sLang.startsWith ("ja"))
            return PuzzlesOverES;
        else
            return PuzzlesOverENG;
    }
}
